import random
random.seed("basic03/i-hate-anagrams2")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test([1, 2, 3], [3, 2, 1])
        self.print_test([1, 2, 3], [4, 5, 6])
                                 
    def generate_min_tests(self):
        self.print_test([1], [1])
        self.print_test([1], [2])
        self.print_test([1, 2], [1, 2])
        self.print_test([1, 2], [2, 1])
        self.print_test([1, 2], [1, 1])
        self.print_test([1, 1], [1, 1])
        self.print_test([1, 1, 2, 2], [1, 2, 1, 2])
                          
    def generate_hand_tests(self):
        self.print_test([1, 2, 3, 4], [3, 2, 1, 5])
        self.print_test([1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1], [1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1])

    def generate_random_test(self, maxn, maxx):
        a = []
        for i in range(maxn):
            a.append(random.randint(1, maxx))
        b = []
        bsize = random.randint(maxn // 2, maxn)
        i = 0;
        while i < bsize:
            block = random.randint(1, bsize - i)
            start = random.randint(0, maxn - block)
            sub = a[start:start + block]
            random.shuffle(sub)
            for element in sub:
                b.append(element)
            i += block
            add = random.randint(0, bsize - i)
            for j in range(add):
                if random.randint(1, 2) == 1:
                    b.append(a[random.randint(0, maxn - 1)])
                else:
                    b.append(random.randint(1, maxx))
            i += add
        self.print_test(a, b)

    def generate_tue_morse_string(self, maxn):
        a = [1]
        for i in range(10):
            n = len(a)
            for i in range(n):
                a.append(1 if a[i] == 2 else 2)
        b = [2]
        for i in range(10):
            n = len(b)
            for i in range(n):
                b.append(1 if b[i] == 2 else 2)
        a = a[:1000]
        b = b[:1000]
        self.print_test(a, b);

    def generate_no_answers(self, maxn, maxx):
        a = []
        used = [False for i in range(maxx + 1)]
        for i in range(maxn):
            x = random.randint(1, maxx)
            a.append(x)
            used[x] = True
        b = []
        for i in range(maxn):
            x = random.randint(1, maxx)
            while used[x]:
                x = random.randint(1, maxx)
            b.append(x)
        self.print_test(a, b)

    def generate_max_tests(self, maxn, maxx):
        a = [(maxx - i) for i in range(maxn)]
        b = [(maxx - i) for i in range(maxn)]
        random.shuffle(a)
        random.shuffle(b)
        self.print_test(a, b)

        a = [(maxx - i) for i in range(maxn)]
        b = [(maxx - i) for i in range(maxn)]
        random.shuffle(a)
        random.shuffle(b)
        a[random.randint(0, maxn - 1)] = maxx - maxn
        self.print_test(a, b)

    def print_test(self, a, b):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)

        test_name = "../tests/" + "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(len(a), file=test_file)
        print(' '.join(str(element) for element in a), file=test_file)
        print(len(b), file=test_file)
        print(' '.join(str(element) for element in b), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        maxn = 1000
        maxx = 10**5
        ns = [5, 10, maxn // 40, maxn // 20, maxn // 4, maxn // 2, maxn]
        nx = [5, 10, maxx // 1000, maxx // 100, maxx // 10, maxx]
        for n in ns:
            for x in nx:
                self.generate_random_test(n, x)
        self.generate_tue_morse_string(maxn)
        for i in range(5):
            self.generate_no_answers(maxn, maxx)
        self.generate_max_tests(maxn, maxx)

    def generate_all_tests_argv(self, argv):
        pass            

if __name__ == "__main__":
    import os, shutil
    from sys import argv
    if os.path.exists('../tests'):
        print('Directory <<tests>> already exists')
        shutil.rmtree('../tests', ignore_errors=False, onerror=None)
    try:
        os.makedirs('../tests')
    except OSError:
        pass

    import time
    start = time.time()
    writer = TestGen()
    writer.generate_all_tests()
    #writer.generate_all_tests_argv(argv)
    finish = time.time()
    print('All tests were generated. Elapsed time: ', finish - start)
