#include <bits/stdc++.h>

int main() {
    freopen("bipartite.in", "r", stdin);
    freopen("bipartite.out", "w", stdout);
    int n, m;
    scanf("%d%d", &n, &m);
    std::vector<int> deg(n, 0);
    std::vector<std::vector<int>> graph(n);
    std::vector<std::vector<int>> eids(n);
    for (int i = 0; i < m; i++) {
        int v, u;
        scanf("%d%d", &v, &u);
        deg[--v]++;
        deg[--u]++;
        graph[v].push_back(u);
        graph[u].push_back(v);
        eids[v].push_back(i);
        eids[u].push_back(i);
    }
    std::vector<int> part(n, 0);
    part[0] = 1;
    std::vector<int> good(n, 0);
    std::vector<int> bad(n, 0);
    for (int v = 0; v < n; v++) {
        for (int u : graph[v]) {
            if (part[v] != part[u]) {
                good[v]++;
            } else {            
                bad[v]++;
            }
        }
    }
    while (true) {
        int v = -1;
        for (int i = 0; i < n; i++) {
            if (bad[i] > good[i]) {
                v = i;
                break;
            }
        }
        if (v == -1) {
            break;
        }
        for (int u : graph[v]) {
            if (part[v] == part[u]) {
                --bad[u];
                ++good[u];
            } else {
                --good[u];
                ++bad[u];
            }
        }
        std::swap(good[v], bad[v]);
        part[v] ^= 1;
    }

    std::vector<int> answer;
    for (int v = 0; v < n; v++) {
        for (size_t i = 0; i < graph[v].size(); i++) {
            int u = graph[v][i];
            if (part[v] == part[u] && v < u) {
                answer.push_back(eids[v][i]);
            }
        }
    }
    printf("%d\n", (int)answer.size());
    for (size_t i = 0; i < answer.size(); i++) {
        printf("%d%c", answer[i] + 1, " \n"[i + 1 == answer.size()]);
    }
    return 0;
}