#include <bits/stdc++.h>

struct vertex_degree {
    int good, bad, vertex;

    vertex_degree() : good(0), bad(0), vertex(0) {}
    vertex_degree(int good, int bad, int vertex) : good(good), bad(bad), vertex(vertex) {}

    bool operator < (const vertex_degree &v) const {
        return good - bad < v.good - v.bad;
    }
};

int main() {
    freopen("bipartite.in", "r", stdin);
    freopen("bipartite.out", "w", stdout);
    int n, m;
    scanf("%d%d", &n, &m);
    std::vector<int> deg(n, 0);
    std::vector<std::vector<int>> graph(n);
    std::vector<std::vector<int>> eids(n);
    for (int i = 0; i < m; i++) {
        int v, u;
        scanf("%d%d", &v, &u);
        deg[--v]++;
        deg[--u]++;
        graph[v].push_back(u);
        graph[u].push_back(v);
        eids[v].push_back(i);
        eids[u].push_back(i);
    }
    std::vector<int> part(n, 0);
    part[0] = 1;

    std::set<vertex_degree> ds;
    for (int v = 0; v < n; v++) {
        vertex_degree nv;
        nv.vertex = v;
        for (int u : graph[v]) {
            if (part[v] != part[u]) {
                nv.good++;
            } else {            
                nv.bad++;
            }
        }
        ds.insert(nv);
    }
    while (true) {
        vertex_degree v = *ds.begin();
        ds.erase(ds.begin());
        if (v.bad <= v.good) {        
            break;
        }
        std::swap(v.good, v.bad);
        part[v.vertex] ^= 1;
        ds.insert(v);
    }

    std::vector<int> answer;
    for (int v = 0; v < n; v++) {
        for (size_t i = 0; i < graph[v].size(); i++) {
            int u = graph[v][i];
            if (part[v] == part[u] && v < u) {
                answer.push_back(eids[v][i]);
            }
        }
    }
    printf("%d\n", (int)answer.size());
    for (size_t i = 0; i < answer.size(); i++) {
        printf("%d%c", answer[i] + 1, " \n"[i + 1 == answer.size()]);
    }
    return 0;
}