import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;
import static ru.ifmo.testlib.Outcome.Type.*;

import java.util.ArrayList;
import java.util.Arrays;

public class Check implements Checker {
    public Outcome outcome(Outcome.Type type, final String format, final Object... args) {
        return new Outcome(type, String.format(format, args));
    }

    boolean cmp(int[] a, int[] b) {
        int cnt = 0;
        for (int i = 0; i < a.length; ++i) {
            if (b[i] > a[i])
                cnt++;
        }
        return cnt > a.length / 2;
    }

    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        int n = inf.nextInt();
        int k = inf.nextInt();
        int[][] mtr = new int[n][k];
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < k; ++j) {
                mtr[i][j] = ouf.nextInt();
                if (mtr[i][j] > 10 || mtr[i][j] < 0)
                    return outcome(WA, String.format("Bad element: %d", mtr[i][j]));
            }
            if (i != n - 1)
                ouf.nextLine();
        }
        int bad = -1;
        for (int i = 0; i < n; ++i) {
            if(!cmp(mtr[i], mtr[(i+1)%n])) 
                return outcome(WA, String.format("%d array not greater, than %d+1", bad, bad));    
        }
        return outcome(OK, "Corrent answer");
    }
}
