import java.io.*;
import java.util.*;

public class TestGen {

    static PrintWriter out;
    static Random rnd = new Random(0);
    static int tNumber = 1;
    
    
    static void printTest(int n, int k) throws IOException {
        System.out.println(String.format("Generating test %d", tNumber));
        out = new PrintWriter(String.format("../tests/%02d", tNumber++));
        out.println(n + " " + k);
        out.close();
    }

    
    static void genSample() throws IOException {
        printTest(7, 5);
    }
    
    static int randFromTo(int l, int r) {
        return rnd.nextInt(r - l + 1) + l;      
    }

    public static void main(String[] args) throws IOException {
        new File("../tests").mkdir();        
        genSample();
        for (int i = 0; i < 5; ++i) {
            printTest(4+i, 4+i);
        }
        for (int i = 0; i < 5; ++i) {
            printTest(randFromTo(50, 100), 4);
        }
        printTest(48, 4);
        for (int i = 0; i < 10; ++i) {
            printTest(randFromTo(50, 100-i)/4*4 + i, 4);
        }
        for (int i = 0; i < 5; ++i) {
            printTest(randFromTo(10, 50), randFromTo(50, 100));
        }
        for (int i = 0; i < 5; ++i) {
            printTest(randFromTo(50, 100), randFromTo(10, 50));
        }
        for (int i = 0; i < 10; ++i) {
            printTest(randFromTo(50, 100), randFromTo(50, 100));
        }
        printTest(100, 100);
    }                 
}


