import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;

import java.util.HashMap;

public class Check implements Checker {
    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {

        String act = ouf.nextToken();
        String exp = ans.nextToken();

        if (!exp.equals(act) && act.equals("NO")) {
            return new Outcome(Outcome.Type.WA, String.format("Expected %s, but found %s", exp, act));
        }

        if (act.equals("YES")) {

            int n = inf.nextInt();
            int m = inf.nextInt();

            int[] a = new int[n];
            int[] b = new int[m];

            for (int i = 0; i < n; i++) {
                a[i] = inf.nextInt();
            }

            for (int i = 0; i < m; i++) {
                b[i] = inf.nextInt();
            }

            int[] aSum = new int[n];
            int[] bSum = new int[m];

            boolean[][] graph = new boolean[n][m];
            int all = ouf.nextInt();
            for (int i = 0; i < all; i++) {
                int x = ouf.nextInt() - 1;
                if (!(x >= 0 && x < n))
                    return new Outcome(Outcome.Type.WA, String.format("Incorrect x #%d", i + 1));
                int y = ouf.nextInt() - 1;
                if (!(y >= 0 && y < m))
                    return new Outcome(Outcome.Type.WA, String.format("Incorrect y #%d", i + 1));
                if (graph[x][y])
                    return new Outcome(Outcome.Type.WA, String.format("Dublicate edge %d %d", x + 1, y + 1));
                graph[x][y] = true;
                aSum[x]++;
                bSum[y]++;
            }

            for (int i = 0; i < n; i++) {
                if (aSum[i] != a[i]) return new Outcome(Outcome.Type.WA, String.format("a[%d] != aSum[%d]", i, i));
            }

            for (int i = 0; i < m; i++) {
                if (bSum[i] != b[i]) return new Outcome(Outcome.Type.WA, String.format("b[%d] != bSum[%d]", i, i));
            }

            if (exp.equals("NO"))
                return new Outcome(Outcome.Type.FAIL, String.format("Contestant finds anwer, jury not"));
        }

        return new Outcome(Outcome.Type.OK, String.format("%s", act));
    }
}
