import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;

public class Interact {
    private final static int MAX_VALUE = 1000;
    private final static int MAX_TURNS = 50;
    
    static int sign(int x) {
        return x > 0 ? 1 : (x == 0 ? 0 : -1);
    }
    
    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(new File("line.in"));
        Scanner part = new Scanner(System.in);
        PrintWriter out = new PrintWriter(System.out);

        int k = in.nextInt();
        int b = in.nextInt();
        int kStart = k, bStart = b;
        int turns = 0;
        
        while (true) {
            if (++turns > MAX_TURNS) {
                WA("Too many turns");
                return;
            }
        
            int type, k0, b0;
            try {
                type = part.nextInt();
                k0 = part.nextInt();
                b0 = part.nextInt();
            } catch (Throwable e) {
                PE("Wrong numbers in query");
                return;
            }
            if (k0 < -5 * MAX_VALUE || k0 > 5 * MAX_VALUE || b0 < -5 * MAX_VALUE || b0 > 5 * MAX_VALUE) {
                PE(String.format("k0, b0 must be from %d to %d, but found %d and %d", -5 * MAX_VALUE, 5 * MAX_VALUE, k0, b0));
                return;
            }
            if (type == 1) {
                if (k0 != kStart || b0 != bStart) {
                    System.err.println(k0 + " " + b0);
                    WA(String.format("Wrong answer - expected (k = %d, b = %d), found (k = %d, b = %d)", kStart, bStart, k0, b0));
                    return;
                }
                OK(turns);
                return;
            }
            if (k == 0 && b == 0) {
                out.println(-1);
                out.flush();
            } else if (k == 0) {
                out.println(0);
                out.flush();
            } else {
                if (sign(k) != sign(b) && sign(b) != 0) {
                    out.println("1 1");
                } else {
                    out.println("1 -1");
                }
                out.flush();
            }
            k += k0;
            b += b0;
        }
    }

    private static void OK(int cnt) throws FileNotFoundException {
        PrintWriter pw = new PrintWriter("line.out");
        pw.print("OK ");
        pw.println("Contestant found the way after " + cnt + " moves");
        pw.close();
    }

    private static void PE(String s) throws FileNotFoundException {
        PrintWriter pw = new PrintWriter("line.out");
        pw.print("PE ");
        pw.println(s);
        pw.close();
    }

    private static void WA(String string) throws FileNotFoundException {
        PrintWriter pw = new PrintWriter("line.out");
        pw.print("WA ");
        pw.println(string);
        pw.close();
    }
}
