@echo off

set author=dp
set fail_test=""

for %%i in (.) do set problem=%%~ni

mkdir tests

cd src
echo Compiling generator
rem javac TestGen.java || goto CompGenError
python TestGen.py
echo Generating tests...
rem java -ea TestGen || goto GenError
cd ..

echo Compiling validator
if EXIST Validate.java (javac Validate.java || goto continue)
:continue

echo Compiling author solution
if EXIST %problem%_%author%.cpp (g++ %problem%_%author%.cpp -o %problem%_%author%.exe || goto CompSourceError)
if EXIST %problem%_%author%.pas (dcc32 -cc %problem%_%author%.pas || goto CompSourceError)
if EXIST %problem%_%author%.java (javac %problem%_%author%.java -encoding utf8 || goto CompSourceError)

rem javac %problem%_%author%.java || goto CompSourcesError

if exist check.dpr dcc32 -U..\..\..\lib -cc check.dpr
if exist Check.java javac -classpath ../../../lib/testlib4j.jar Check.java -encoding utf8 
if exist Check.class jar cf Check.jar *.class

if exist Interact.java javac Interact.java -encoding utf8
call packInteractor.bat

echo Generating answers...
for %%i in (tests\??) do (
    echo Test %%i
    copy %%i %problem%.in > nul
    copy nul %problem%.out > nul
    
    if exist %problem%_%author%.exe coact.exe  5s 268435456 "java Interact"  %problem%_%author%.exe 
    if exist %problem%_%author%.class coact.exe  5s 268435456 "java Interact"  "java %problem%_%author%"



    copy nul %%i.a > nul
    if exist Validate.class (
        java Validate < %problem%.in
        if errorlevel 1 (
            echo Validator doesn't accept test %%i
            goto End
        )
        echo Validator accepts test %%i
    )

    set fail_test = %%i

    rem copy %problem%.out %%i.a > nul
    rem if exist check.exe check %%i %%i.a %%i.a
    if exist Check.class java -Xmx256M -Xss64M -cp ../../../lib/testlib4j.jar;. ru.ifmo.testlib.CheckerFramework Check %%i %problem%.out %%i.a
)

goto End

:CompGenError 
  echo Cannot compile generator
  goto End
:CompValError 
  echo Cannot compile validator
  goto End
:GenError 
  echo Cannot generate tests
  goto End
:CompSourcesError
  echo Cannot compile source
  goto End
:SourceRunningError
  echo Fail in generating answers on test %fail_test%

:End

rem call clean
