import random
random.seed("basic03/line")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test(1, 1)

    def generate_min_tests(self):
        self.print_test(1, 2)
        self.print_test(2, 1)
        self.print_test(-1, 0)
        self.print_test(-1, -1)
        self.print_test(-1, 1)
        self.print_test(-2, 0)
        self.print_test(-2, -1)
        self.print_test(-2, -2)
        self.print_test(-2, 1)
        self.print_test(-2, 2)
        
                                                              
    def generate_hand_tests(self):
        self.print_test(-500, 0)
        self.print_test(500, 0)
        self.print_test(-501, 0)
        self.print_test(501, 0)
        self.print_test(1, -500)
        self.print_test(-1, 500)
        self.print_test(1, -501)
        self.print_test(-1, 501)

    def generate_random_test(self, maxn):
        k = random.randint(-maxn, maxn)
        while k == 0:
            k = random.randint(-maxn, maxn)
        b = random.randint(-maxn, maxn)
        self.print_test(k, b)

    def generate_max_tests(self, maxn):
        self.print_test(maxn, 0)
        self.print_test(-maxn, 0)
        self.print_test(maxn, maxn);
        self.print_test(-maxn, -maxn)
        self.print_test(-maxn, maxn)
        self.print_test(maxn, -maxn)
        
    def print_test(self, k, b):
        self.test_number += 1
        test_name = "../tests/" + "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(k, b, file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()                            
        self.generate_min_tests()                          
        self.generate_hand_tests()                         

        maxn = 1000
        for i in range(30):
            self.generate_random_test(maxn)
        self.generate_max_tests(maxn)                     

import os, shutil
if os.path.exists('../tests'):
    print('Directory <<tests>> already exists')
    shutil.rmtree('../tests', ignore_errors=False, onerror=None)
try:
    os.makedirs('../tests')
except OSError:
    pass

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)