import java.util.*;
import java.io.*;

public class maxxor_ip_ternary_tl {
    FastScanner in;
    PrintWriter out;

    final String TASK_NAME = "maxxor";
    final int MAX_N = 1_000_00;
    final int H = 20;

    public void solve() throws IOException {
        int n = in.nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; ++i)
            a[i] = in.nextInt();
        int[] b = new int[n];
        System.arraycopy(a, 0, b, 0, n);
        Arrays.sort(b);

        int l = 0, r = n - 1;
        while (r - l >= 3) {
            int m1 = (2 * l + r) / 3;
            int m2 = (l + 2 * r) / 3;
            if (f(b[m1], a) > f(b[m2], a)) r = m2;
            else l = m1;
        }
        long ans = 0;
        for (; l <= r; ++l)
            ans = Math.max(ans, f(b[l], a));
        out.println(ans);
    }

    private long f(int m, int[] a) {
        long ans = 0;
        for (int i = 0; i < a.length;) {
            if (a[i] > m) {
                ++i;
                continue;
            }
            int j = i;
            while (i < a.length && a[i] <= m) ++i;

            for (int e1 = j; e1 < i; ++e1) {
                int xr = 0;
                for (int e2 = e1; e2 < i; ++e2) {
                    xr ^= a[e2];
                    ans = Math.max((long)xr * m, ans);
                }
            }
        }
        return ans;
    }

    public void run() {
        try {
            in = new FastScanner(new File(TASK_NAME + ".in"));
            out = new PrintWriter(new File(TASK_NAME + ".out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new maxxor_ip_ternary_tl().run();
    }
}