import java.util.*;
import java.io.*;

public class maxxor_ip {
    FastScanner in;
    PrintWriter out;

    final String TASK_NAME = "maxxor";
    final int MAX_N = 1_000_00;
    final int H = 20;

    public void solve() throws IOException {
        long lTime = System.currentTimeMillis();
        int n = in.nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; ++i)
            a[i] = in.nextInt();

        out.println(calc(a, 0, n));
        System.out.println((System.currentTimeMillis() - lTime) / 1000.0);
    }

    private long calc(int[] a, int l, int r) {
        if (r - l == 1)
            return (long) a[l] * a[l];
        int m = (l + r) / 2;
        long lefAns = calc(a, m, r);
        long rigAns = calc(a, l, m);
        long ans = 0;
        int leftXor = 0, mx = a[m - 1];
        int rightXor = 0;
        Trie trieRight = new Trie();
        for (int i = m; i < r; ++i) {
            rightXor ^= a[i];
            trieRight.insert(rightXor);
        }

        for (int i = m - 1; i >= l; --i) {
            leftXor ^= a[i];
            mx = Math.max(mx, a[i]);
            int maxPref = trieRight.getMax(leftXor);
            ans = Math.max(ans, (long) mx * maxPref);
        }
        return Math.max(Math.max(lefAns, rigAns), ans);
    }

    class Trie {
        List<Integer>[] t = new ArrayList[2];

        public Trie() {
            t[0] = new ArrayList<>();
            t[1] = new ArrayList<>();
            t[0].add(null);
            t[1].add(null);
        }

        public void insert(int x) {
            int v = 0;
            for (int i = H - 1; i >= 0; --i) {
                int bit = (x>>i)&1;
                if (t[bit].get(v) == null) {
                    t[0].add(null);
                    t[1].add(null);
                    t[bit].set(v, t[0].size() - 1);
                }
                v = t[bit].get(v);
            }
        }

        public int getMax(int leftXor) {
            if (t[0].size() == 1)
                return leftXor;
            int v = 0;
            for (int b = H - 1; b >= 0; --b) {
                int bit = ((leftXor>>b)&1) ^ 1;
                if (t[bit].get(v) != null) {
                    leftXor ^= bit<<b;
                    v = t[bit].get(v);
                } else {
                    leftXor ^= (bit^1)<<b;
                    v = t[bit ^ 1].get(v);
                }
            }
            return leftXor;
        }
    }

    public void run() {
        try {
            in = new FastScanner(new File(TASK_NAME + ".in"));
            out = new PrintWriter(new File(TASK_NAME + ".out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new maxxor_ip().run();
    }
}