import random
from string import ascii_lowercase

random.seed(":)))")

def random_pair(n):
    a = random.randint(1, n)
    b = random.randint(1, n)
    return (min(a, b), max(a, b))

def random_string(n):
    return "".join([ random.choice(ascii_lowercase) for i in range(n) ])

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test("hello", [(1, 5), (1, 2), (2, 5)])
        self.print_test("fedcba", [(1, 6)])

    def generate_handmade_tests(self):
        self.print_test("abra", [(1, 1), (2, 2), (1, 2), (3, 3), (4, 4), (1, 4), (2, 2)])
        self.print_test("a", [(1, 1)])

    def generate_random(self, n, m):
        s = random_string(n)
        q = [ random_pair(n) for i in range(m)]
        self.print_test(s, q)

    def generate_max_ans(self, n, m):
        count = 0
        while 26 * count <= n:
            count += 1
        count -= 1
        s = ascii_lowercase * count + ascii_lowercase[: n - 26 * count]
        q = [ (1, n) for i in range(m) ]
        self.print_test(s, q)

    def generate_min_ans(self, n, m):
        count = [n // 26] * 26
        count[0] += n % 26
        s = "".join([ chr(i + ord('a')) * count[i] for i in range(26) ])
        q = [ (1, n) for i in range(m) ]
        self.print_test(s, q)

    def print_test(self, s, q):
        self.test_number += 1
        test_name = "../tests/" + "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(s + "\n" + str(len(q)) + "\n" + "\n".join(map(lambda x: str(x[0]) + " " + str(x[1]), q)), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()                            
        self.generate_handmade_tests()

        self.generate_random(5, 30)
        self.generate_random(5, 30)
        self.generate_random(5, 30)

        self.generate_max_ans(100000, 100000)
        self.generate_random(100000, 100000)

        self.generate_random(30, 30)
        self.generate_random(30, 30)
        self.generate_random(100, 100000)
        self.generate_random(30, 100000)
        self.generate_random(10, 100000)
        self.generate_random(10, 100000)
        self.generate_random(10, 100000)
        self.generate_random(1, 100000)
        self.generate_random(2, 100000)
        self.generate_random(5, 100000)
        self.generate_random(5, 100000)
        self.generate_max_ans(30, 10)
        self.generate_min_ans(30, 10)

        self.generate_max_ans(100000, 100000)
        self.generate_min_ans(100000, 100000)
        self.generate_random(100000, 100000)
        self.generate_random(100000, 100000)
        self.generate_random(100000, 100000)
        self.generate_random(100000, 100000)
        self.generate_random(100000, 100000)
        
import os, shutil
if os.path.exists('../tests'):
    print('Directory <<tests>> already exists')
    shutil.rmtree('../tests', ignore_errors=False, onerror=None)
try:
    os.makedirs('../tests')
except OSError:
    pass

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
