#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <cstring>
#include <cstdlib>
#include <cassert>
#include <queue>
#define NAME "queue"
#define mp make_pair
#define pb push_back
 
using namespace std;
 
typedef long long ll;
const long long INF = 1000000000000000000LL;
const auto comp = [](pair<int, int> a, pair<int, int> b) {return a.first < b.first || (a.first == b.first && a.second > b.second);};
int n, m, k;
int t[100000];
int h[100000];
long long ans[100000];

int best(long long cur_t, int v1, int v2, int v3) {
    long long tv1, tv2, tv3;
    if (v1 != -1) tv1 = (k - (cur_t - t[v1]) % k) % k;
    else tv1 = INF;

    if (v2 != -1) tv2 = (k - (cur_t - t[v2]) % k) % k;
    else tv2 = INF;

    if (v3 != -1) tv3 = (k - (cur_t - t[v3]) % k) % k;
    else tv3 = INF;
    
    vector<pair<long long, int>> tmp({make_pair(tv1, v1), make_pair(tv2, v2), make_pair(tv3, v3)});
    sort(tmp.begin(), tmp.end());
    return tmp[0].second;    
}

int who_come(long long cur_t, set<pair<int, int>, decltype(comp)> const& st) {
    if (st.size() == 0)
        return -1;        
    auto tmp = st.upper_bound(make_pair(cur_t%k, n+1));
    int v1 = tmp == st.begin() ? -1 : (*(--tmp)).second;    
    int v2 = st.begin() == st.end() ? -1 : (*(--st.end())).second;
    tmp = st.upper_bound(make_pair(k - cur_t%k, -1));
    int v3 = tmp == st.begin() ? -1 : (*(--tmp)).second;
    return best(cur_t, v1, v2, v3);        
}

int main() {
    freopen("queue.in", "r", stdin);
    freopen("queue_tl.out", "w", stdout);
    scanf("%d%d%d", &n, &m, &k);
    for (int i = 0; i < n; ++i) {
        scanf("%d%d", &t[i], &h[i]);
    }
    while (s1.size() != 0)
    {
        ll t = s1.begin()->first;
        int id = s1.begin()->second;
        s1.erase(mp(t, id));
        if (id == -1)
        {
            cn--;
            if (s2.size() == 0) continue;
            siter it = s2.lower_bound(mp(t % k, 0));
            if (it == s2.end()) it = s2.begin();
            ll nt = t - (ll)(t % k) + it->first;
            if (nt < t) nt += k;
            s1.insert(mp(nt, it->second));
            s2.erase(mp(it->first, it->second));
        }
        else if (cn != m)
        {
            ac = max(ac, t) + h[id];
            ans[id] = ac;
            cn++;
            s1.insert(mp(ac, -1));
        }
        else
        {
            s2.insert(mp(t % k, id));
        }
    }
    for (int i = 0; i < n; i++) 
    {
        assert(ans[i] != -1);
        cout << ans[i] << endl;
    }
    return 0;
}