import java.util.*;
import java.io.*;

public class strings_ip_brute_tl2 {
    FastScanner in;
    PrintWriter out;
    final String TASK_NAME = "strings";

    final int MAX_N = 1000_00;

    final int[] pw = new int[MAX_N + 1];
    final int MOD = 1_000_000_000 + 7;
    final int P = 31;

    final int INF = 1_000_000_000;

    Trie trieSuff = new Trie();
    Trie triePref = new Trie();
    TreeMap<Integer, Integer> dp = new TreeMap<>();

    private void calcHashString(StringBuilder s, int[] h) {
        int n = s.length();
        for (int i = 0; i < n; i++) {
            int add = (int)((long)pw[i] * (s.charAt(i) - 'a' + 1) % MOD);
            h[i + 1] = (h[i] + add) % MOD;
        }
    }

    public int gen(StringBuilder s, int[] h) {
        if (s.length() == 0)
            return 0;
        int hashS = h[s.length() - 1];
        if (dp.containsKey(hashS))
            return dp.get(hashS);

        int n = s.length();
        Node cur = triePref.root;
        int t = Math.min(101, n);
        int mn = INF;

        for (int i = 2; i + 1 <= t; ++i) {
            cur = cur.to[s.charAt(i - 1) - 'a'];
            if (cur == null) break;
            if (!cur.leaf || n % i != 0) continue;
            int hash = getHash(1, i, h);
            boolean fail = false;

            for (int j = i; j + i <= n; j += i)
                if (getHash(j + 1, j + i, h) != hash) {
                    fail = true;
                    break;
                }
            if (!fail) {
                StringBuilder to = new StringBuilder();
                for (int j = 0; j < n; j += i)
                    to.append(s.charAt(j));
                int[] newH = new int[to.length() + 1];
                calcHashString(to, newH);
                mn = Math.min(mn, gen(to, newH) + 1);
            }
        }

        cur = trieSuff.root;
        t = Math.min(s.length(), 100);
        StringBuilder sb = new StringBuilder();
        for (int i = 1; i <= t; ++i) {
            sb.append(s.charAt(s.length() - 1));
            int c = s.charAt(s.length() - 1) - 'a';
            cur = cur.to[c];
            if (cur == null) break;
            s.deleteCharAt(s.length() - 1);
            if (cur.leaf)
                mn = Math.min(mn, gen(s, h) + 1);
        }
        s.append(sb.reverse());
        dp.put(hashS, mn);
        return mn;
    }

    public void solve() throws IOException {
        String s = in.next();
        int k = in.nextInt();
        String[] a = new String[k];
        int mxLen = 0;

        for (int i = 0; i < k; ++i) {
            a[i] = in.next();
            if (a[i].length() > mxLen) mxLen = a[i].length();

            StringBuilder builder = new StringBuilder(a[i]);
            triePref.insert(builder);
            trieSuff.insert(builder.reverse());
        }

        pw[0] = 1;
        for (int i = 1; i <= MAX_N; ++i)
            pw[i] = (int)((long)pw[i - 1] * P % MOD);
        StringBuilder sb = new StringBuilder(s);
        int[] h = new int[sb.length() + 1];
        calcHashString(sb, h);
        int val = gen(sb, h);
        if (val == INF) out.println(-1);
        else out.println(val);
    }

    private int getHash(int i, int j, int[] h) {
        int diff = h[j] - h[i];
        if (diff < 0) diff += MOD;
        return (int)((long) diff * pw[MAX_N - i] % MOD);
    }

    class Node {
        public static final int K = 26;
        boolean leaf;
        Node[] to = new Node[K];
    }

    class Trie {
        public int size = 1;
        public Node root = new Node();

        public void insert(StringBuilder s) {
            Node v = root;
            for (int i = 0; i < s.length(); ++i) {
                int c = s.charAt(i) - 'a';
                Node to = v.to[c];
                if (to == null) {
                    to = new Node();
                    v.to[c] = to;
                    size++;
                }
                v = to;
            }
            v.leaf = true;
        }
    }

    public void run() {
        try {
            in = new FastScanner(new File(TASK_NAME + ".in"));
            out = new PrintWriter(new File(TASK_NAME + ".out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new strings_ip_brute_tl2().run();
    }
}
