import java.util.*;
import java.io.*;

public class strings_ip_mem_tl {
    FastScanner in;
    PrintWriter out;
    final String TASK_NAME = "strings";

    final int MAX_N = 1000_00;

    final int[] pw = new int[MAX_N + 1];
    final int[] h = new int[MAX_N + 1];
    final int MOD = 1_000_000_000 + 7;
    final int P = 31;
    final int INF = 1_000_000_000;
    ArrayList<ArrayList<Integer>> graph;

    int[] cnt;
    int[] dp, D, L;

    Trie trieSuff = new Trie();
    Trie triePref = new Trie();
    StringBuilder s;

    public int gen(int d, int l) {
        if (l == 0)
            return 0;
        if (l == 1 && d != 1)
            return gen(1, 1);

        if (dp[cnt[d - 1] + l] != INF)
            return dp[cnt[d - 1] + l];

        Node cur = trieSuff.root;
        int t = Math.min(l, 100);
        int mn = INF;
        for (int i = 1; i <= t; ++i) {
            int c = s.charAt((l - i) * d) - 'a';
            cur = cur.to[c];
            if (cur == null) break;
            if (cur.leaf)
                mn = Math.min(mn, gen(d, l - i) + 1);
        }

        if (l != 1) {
            for (Integer to : graph.get(cnt[d - 1] + l))
                mn = Math.min(mn, gen(D[to], L[to]) + 1);
        }
        return dp[cnt[d - 1] + l] = mn;
    }

    public void solve() throws IOException {
        long l = System.currentTimeMillis();
        String s = in.next();
        int k = in.nextInt();
        String[] a = new String[k];
        int mxLen = 0;
        this.s = new StringBuilder(s);

        for (int i = 0; i < k; ++i) {
            a[i] = in.next();
            if (a[i].length() > mxLen) mxLen = a[i].length();

            StringBuilder builder = new StringBuilder(a[i]);
            trieSuff.insert(builder.reverse());
            triePref.insert(builder);
        }

        pw[0] = 1;
        for (int i = 1; i <= MAX_N; ++i)
            pw[i] = (int)((long)pw[i - 1] * P % MOD);
        cnt = new int[s.length() + 1];
        for (int i = 1; i <= s.length(); ++i)
            cnt[i] = cnt[i - 1] + s.length() / i;
        int vertexes = cnt[s.length()];
        dp = new int[vertexes + 1];
        for (int i = 1; i <= vertexes; ++i) dp[i] = INF;

        graph = new ArrayList<>(vertexes);
        for (int i = 0; i < vertexes; ++i) graph.add(new ArrayList<>());

        int n = s.length();
        for (int d = 1; d < n; ++d) {
            calcHashForD(s, d);
            int t = n / d, hashRef;
            int bound = Math.min(mxLen + 1, t);
            Node curV = triePref.root;
            for (int j = 2; j <= bound; ++j) {
                curV = curV.to[s.charAt(d * (j - 1)) - 'a'];
                if (curV == null) break;
                if (!curV.leaf) continue;
                hashRef = getHash(1, j);
                graph.get(cnt[d - 1] + j).add(1);

                for (int p = j, u = 1; p + j <= t; p += j, ++u) {
                    int curHash = getHash(p + 1, p + j);
                    if (curHash != hashRef)
                        break;
                    graph.get(cnt[d - 1] + p + j).add(cnt[j * d - 1] + u + 1);
                }
            }
        }

        D = new int[vertexes + 1];
        L = new int[vertexes + 1];
        D[1] = 1;
        L[1] = 1;

        int e = 1;
        for (int d = 1; d <= n; ++d) {
            ++e;
            int t = n / d;
            for (int i = 2; i <= t; ++i) {
                D[e] = d;
                L[e] = i;
                ++e;
            }
        }
        System.err.println("START ");
        int val = gen(1, s.length());
        if (val == INF) out.println(-1);
        else out.println(val);
        System.err.println((System.currentTimeMillis() - l) / 1000.0);
    }

    private int getHash(int i, int j) {
        int diff = h[j] - h[i];
        if (diff < 0) diff += MOD;
        return (int)((long) diff * pw[MAX_N - i] % MOD);
    }

    private void calcHashForD(String s, int d) {
        int n = s.length();
        for (int i = 0; i * d < n; i++) {
            int add = (int)((long)pw[i] * (s.charAt(i * d) - 'a' + 1) % MOD);
            h[i + 1] = (h[i] + add) % MOD;
        }
    }


    class Node {
        public static final int K = 26;
        boolean leaf;
        Node[] to = new Node[K];
    }

    class Trie {
        public int size = 1;
        public Node root = new Node();

        public void insert(StringBuilder s) {
            Node v = root;
            for (int i = 0; i < s.length(); ++i) {
                int c = s.charAt(i) - 'a';
                Node to = v.to[c];
                if (to == null) {
                    to = new Node();
                    v.to[c] = to;
                    size++;
                }
                v = to;
            }
            v.leaf = true;
        }
    }

    public void run() {
        try {
            in = new FastScanner(new File(TASK_NAME + ".in"));
            out = new PrintWriter(new File(TASK_NAME + ".out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new strings_ip_mem_tl().run();
    }
}